import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Un aro que gira e incrementa los puntos del starFox
 * 
 * @author Luis Guajardo Olvera
 * @author Daniel Romero Martí
 */
public class Aro extends Checkpoints
{
    private GreenfootImage [] arreglo; 

    /**
     * Constructor de la clase Aro
     */
    public Aro()
    {
        super();
        arreglo = new GreenfootImage[16];
        for(int i=0;i<16;i++)
            arreglo[i] = new GreenfootImage("aro"+i+".png");
        super.puntos(20);
    }

    /**
     * Act - do whatever the Aro wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    { 
        super.act(super.puntos());
        turn(3);
    }    

    /**
     * Incrementa el tamaño del objeto
     */
    public void escala()
    { 
        if(super.aumentaTam()==10 && super.profundidad() !=16)
        {
            setImage(arreglo[super.profundidad()]);
            int prof = super.profundidad();
            super.profundidad(prof+1);
            super.aumentaTam(0);
        }
    }

    /**
     * Remueve al objeto del mundo
     */
    public void desaparece()
    { 
        if(super.profundidad()==16)
        { World mundo;
            mundo=getWorld();
            mundo.removeObject(this);
        }
    }
}