import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Edificio que se cae en el mundo
 * 
 * @author Luis Guajardo Olvera
 * @author Daniel Romero Martí
 */
public class Destruido extends Obstaculo
{   
    /**
     * Constructor de la clase Destruido
     */
    public Destruido()
    {
        super.damage(2);
        super.aumentaTam(0);
    }

    /**
     * Act - do whatever the Destruido wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        super.act(super.damage());

    }    

    /**
     * Mueve al objeto en el mundo
     */
    public void mueve()
    { 
        setLocation(getX(),getY()+1);
        this.gira();
        this.escala();
    }

    /**
     * Hace girar al objeto 90º hacia la derecha o la izquierda, dependiendo de su posicion inicial
     */
    public void gira()
    {
        World mundo = getWorld();
        GreenfootImage image = getImage();
        //image.scale(image.getWidth()+1,image.getHeight()+2);
        if(getX()<= (mundo.getWidth()/2))
        { if(getRotation()<90)
                turn(1);
        }
        else
        {
            if(getRotation()==0)
                turn(-1);
            if(getRotation()>270)
                turn(-1);
        }
    }

    /**
     * Hace crecer al objeto
     */
    public void escala()
    { 
        World mundo = getWorld();
        GreenfootImage image = getImage();
        if(super.aumentaTam()==5)
        {
            int prof = super.profundidad();
            super.profundidad(prof+1);
            super.aumentaTam(0);
        }
        if(super.profundidad()<=10)
            image.scale(image.getWidth()+1,image.getHeight()+2);
        setLocation(getX(),getY()+1);
    }

}
