import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Portería pegada al suelo que incrementa el puntaje del StarFox
 * 
 * @author Luis Guajardo Olvera
 * @author Daniel Romero Martí
 */
public class Porteria extends Checkpoints
{   
    private GreenfootImage [] arreglo;
    
    /**
     * Costructor de objetos de la clase Porteria
     */
    public Porteria() 
    { 
        super();
        arreglo = new GreenfootImage [16];
        for(int i=0;i<16;i++)
            arreglo[i]=new GreenfootImage("porteria"+i+".png");
        super.puntos(30);
    }

    /**
     * Método de actua
     */
    public void act()
    {
        mueve();
        super.act(super.puntos());
    }

    /**
     * Método que simula el movimiento hacia enfrente e incrementa el tamaño del objeto
     */
    public void escala()
    { 
        if(super.aumentaTam()==10 && super.profundidad()!=16)
        { setImage(arreglo[super.profundidad()]);
           int prof = super.profundidad();
           super.profundidad(prof+1);
           int tam = super.aumentaTam();
           super.aumentaTam(0);
        }
    }

    /**
     * Método que desaparece al objeto del mundo
     */ 
    public void desaparece()
    {  World mundo;
        mundo=getWorld();
        if(getY()>mundo.getHeight()-10)  
            mundo.removeObject(this);

    }

    /**
     * Método que mueve al objeto en el mundo
     */
    public void mueve()
    {
        if(getX()<225)
            setLocation(getX()-1,getY()+1);
        else if(getX()>300)
            setLocation(getX()+1,getY()+1);
        else
            setLocation(getX(),getY()+1);
    }
}
