import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Maneja el puntaje del usuario
 * 
 * @author Luis Guajardo Olvera
 * @author Daniel Romero Martí
 */
public class Puntos extends Actor
{
    private int puntos;

    /**
     * Constructor de la clase Puntos
     */
    public Puntos()
    {
        puntos=0;
        setImage(new GreenfootImage("Puntos: "+puntos,20,Color.WHITE,Color.BLACK));
    }

    /**
     * Método que incrementa la variable "puntos"
     */
    public void incrementaPuntos(int unaCantidad)
    {
        puntos+=unaCantidad;
        setImage(new GreenfootImage(""+puntos,20,Color.WHITE,Color.BLACK));
    }
    
    /**
     * Método que regresa el valor de la variable "puntos"
     */
    public int regresaPuntos()
    {
        return puntos;
    } 
    
    
    /**
    * Éste método actualiza los puntos que el jugador ha ido acumulando durante el juego
    */
    public void actualizaPuntos(int vptos)
    {
     
        if(UserInfo.isStorageAvailable())
        {
       
            UserInfo info=UserInfo.getMyInfo();
            if(vptos>info.getScore())
            {
                info.setScore(vptos);
            }
            info.store();
        }
    }
}
