import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Segundo mundo del juego
 * 
 * @author Luis Guajardo Olvera
 * @author Daniel Romero Martí
 */
public class Space extends Inicio
{

    private StarFox nave;
    private int creador;
    private boolean iniciador;
    private long startTime;
    private long currentTime;
    private int durationMillis;
    private int durationSecs;

    /**
     * Constructor for objects of class Space.
     * 
     */
    public Space(int score)
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(); 
        nave = new StarFox();
        setPaintOrder(StarFox.class);
        creador=0;
        iniciador=false;
        prepare();
        nave.aumentaPuntos(score);
    }
    
    /**
     * Método de actúa
     */
    public void act()
    { 
        if(!iniciador)
        {
            startTime = System.currentTimeMillis();
            iniciador= true;
            super.tocaCancion();
        }
        currentTime = System.currentTimeMillis();
        durationMillis = (int)(currentTime - startTime);
        durationSecs= durationMillis/1000;
        this.cargaEnemigos(durationSecs);
    }
    
    /**
     * Método que carga los enemigos predeterminados para el escenario
     */
    public void cargaEnemigos(int tiempo)
    {
        if(tiempo==2 && creador==0)
        {
            Aro aro = new Aro();
            addObject(aro,298,189);
            creador++;
        }
        if(tiempo==3 && creador==1)
        {
            Caza  caza= new Caza();
            addObject(caza,412,156);
            creador++;
        }
        if(tiempo==5 && creador==2)
        {
           Caza caza = new Caza();
            addObject(caza,209,166);
            creador++;
        }
        if(tiempo==8 && creador==3)
        {
            Aro aro = new Aro();
            addObject(aro,493,113);
            Caza caza = new Caza();
            addObject(caza,184,113);
            creador++;
        }
        if(tiempo==10 && creador==4)
        {
             Bomba bomba= new Bomba(1);
            addObject(bomba,104,162);
            creador++;
        }
        if(tiempo==11 && creador==5)
        {
            Aro aro = new Aro();
            addObject(aro,297,157);
            creador++;
        }
        if(tiempo==14 && creador==6)
        {
            Aro aro= new Aro();
            addObject(aro,297,113);
            creador++;
        }
        if(tiempo==18 && creador==7)
        {
            Caza caza = new Caza();
            addObject(caza,196,157);
            creador++;  
        }
        if(tiempo==20 && creador==8)
        {
            Bomba bom = new Bomba(1);
            creador++;
            addObject(bom,598,157);
            Aro  aro= new Aro();
            addObject(aro,250,162);
            creador++;
        }
        if(tiempo==22 && creador==9)
        {
            Caza caza = new Caza();
            addObject(caza,412,157);
            Caza ed = new Caza();
            addObject(ed,297,113);
            creador++;
        }
        if(tiempo==26 && creador==10)
        {
           Bomba bom = new Bomba(1);
            creador++;
            addObject(bom,598,157);
            Aro  aro= new Aro();
            addObject(aro,250,162);
            creador++;
        }
        if(tiempo==30 && creador==11)
        {
            Aro aro= new Aro();
            addObject(aro,297,113);
            creador++;
        }
        if(tiempo==33 && creador==12)
        {
            StageClear etapa = new StageClear();
            etapa.setImage("stage2.png");
            addObject(etapa,304,69);
            creador++;
        }
        if(tiempo==35 && creador==13)
        {
            super.detieneCancion();
            super.eligeMundo("Meteoro",nave.regresaPuntos());
        }
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        addObject(nave, 303, 224);
    }
}
